# $Id: WallClockSegGenerator.py,v 1.6 2006/02/20 16:36:12 kipp Exp $
#
# Copyright (C) 2005  Kipp C. Cannon
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at your
# option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
# Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

#
# Preamble.
#

from glue import lal
from glue import segments
import onasys.SegGenerator


#
# A segment generator that simply tracks the daemon's clock.
#

class SegGeneratorConfig(onasys.SegGenerator.SegGeneratorConfig):
	def defaults(self):
		return [
			("delay", "0")
		]

	def parse(self):
		self.delay = self.parser.getfloat(self.section, "delay")
		self.initial_epoch = lal.LIGOTimeGPS(self.parser.get(self.section, "initial_epoch"))


class SegGenerator(onasys.SegGenerator.SegGenerator):
	def generate(self, available, clock):
		if clock.now() - self.config.delay < self.config.initial_epoch:
			return {"available": segments.segmentlist()}
		return {"available": segments.segmentlist([segments.segment(self.config.initial_epoch, clock.now() - self.config.delay)])}
